.module template

.include "template.h.s"
.include "assets/sprites.h.s"
.include "man/animation.h.s"
.include "sys/ai.h.s"

.globl cpct_getRandom_mxor_u8_asm
.globl animations_death_small

tempo_vidas_restantes::
    .db vidas_tempo

small_fast_pato_lifes::
    .db small_fast_pato_default_lifes


    
;; #############################################################
;;                      ENTITY DEFINITIONS
;; #############################################################



;; ####################################################################################################################################################################################################################################################################################################################################
;;              name                            type            components                              x   y       w               h               vx  vy  orientation     sprite                              animation                       enemy_type                  ai_state                ai_behaviour
;; ####################################################################################################################################################################################################################################################################################################################################
DefineEntity    taco_entidad                    t_player        c_animated|c_render|c_movable|c_input   42  94      player_width    player_height   0   0   o_left          taco_alto_sprite1                   anim_taco_bajo                  nullptr                     nullptr                 nullptr
DefineEntity    pato_entidad                    t_enemy         c_animated|c_render|c_ai|c_movable      20  30      4               16              1   0   o_left          pato_sprite2                        anim_pato                       et_pato                     basic_pato_down_state   behaviour_pato
DefineEntity    bala_lettuce                    t_bala          c_render|c_movable|c_input              82  14      0               0               0   0   nullptr         bala_h_sprite                       nullptr                         nullptr                     default_ai_state_tempo  nullptr
DefineEntity    pato_small_entidad              t_enemy         c_animated|c_render|c_ai|c_movable      20  30      player_width    player_height   0   0   o_left          pato_small1                         anim_pato_small                 et_pato_small               default_ai_state_tempo  behaviour_pato
DefineEntity    tempo_entidad                   t_enemy         c_animated|c_render|c_ai|c_movable      60  150     4               16              1   0   o_left          tempo_sprite1                       anim_tempo                      et_tempo                    default_ai_state_tempo  behaviour_tempo
DefineEntity    reflective_pato_big_entity      t_enemy         c_render|c_ai|c_movable|c_animated      36  20      8               16              -1  0   o_down          _g_reflective_pato_big_1            anim_reflective_big             et_reflective_pato_big      0                       behaviour_reflective_pato_big
DefineEntity    reflective_pato_small_entity    t_enemy         c_render|c_ai|c_movable|c_animated      38  20      4               16              3   3   o_right         _g_reflective_pato_small_right_1    anim_reflective_small_right     et_reflective_pato_small    0                       behaviour_reflective_pato_small
DefineEntity    tanque_entidad                  t_enemy         c_render|c_ai|c_movable                 4   168     4               16              0   -1  o_left          tanque_sprite1                      15                              et_tanque                   default_state           behaviour_tanque
DefineEntity    fantasma_entidad                t_enemy         c_animated|c_render|c_ai|c_movable      60  150     4               16              1   0   o_left          fantasma_sprite_opaco1              anim_fantasma_opaco             et_fantasma                 default_state           behaviour_fantasma
DefineEntity    bala_enemy                      t_bala_enemy    c_render|c_movable                      82  14      0               0               0   0   0               bala_w_enemy_sprite                 nullptr                         nullptr                     default_ai_state_tempo  nullptr
DefineEntity    popping_entidad                 t_default       c_render|c_ai|c_movable|c_animated      82  14      player_width    player_height   0   0   0               nullptr                             anim_popping                    nullptr                     nullptr                 behaviour_popping



;; INPUT A = bit mask
;; DESTROYS AF, BC, DE, HL
;; RETURNS: (A) random number
get_random::
    push af
    call cpct_getRandom_mxor_u8_asm ; l = random byte
    pop af 
    and l
    ret