.module interrupt

.include "cpctelera.h.s"
.include "man/music.h.s"

.globl cpct_scanKeyboard_f_asm

interruption_no:
   .db 6

;;saves all registers and alternative registers
man_interrupt::
   ex af, af'
   exx
   cpctm_push af, bc, de, hl

   ld a, (interruption_no)
   dec a
   jr nz, man_interrupt_dont_execute
   ;;THIS CODE IS EXECUTED EVERY FRAME

   play_music_cycle_with_check

   call cpct_scanKeyboard_f_asm
   check_mute_music

   ld a, #6
   man_interrupt_dont_execute:
   ld (interruption_no), a
   cpctm_pop hl, de, bc, af
   ex af, af'
   exx
   ei
   reti
