.module mania

.include "cpctelera.h.s"
.include "assets/template.h.s"
.include "man/vecentity.h.s"

.globl cpct_memset_asm

num_ia:: .db 0
_ia_last_ptr:: .dw ia_ptr_array
ia_ptr_array::
    .ds 2*max_entities

;; DESTROY: AF, BC, DE, HL
;; RETURNS: HL: Pointer to start of the pointer array
man_ia_init::

	;; Pointer to array End
	call man_ia_getArray_HL
	ld (_ia_last_ptr), hl

	ex de, hl
	xor a
	ld bc, #max_entities
    call cpct_memset_asm

	xor a
	ld (num_ia), a 

	ret

;; RETURNS HL: Pointer to the array of pointers
man_ia_getArray_HL::
	ld hl, #ia_ptr_array
	ret

;; INPUT: IX: Pointer to the new entity to be added
;; Implements generic function
man_ia_add::
	ld hl, #_ia_last_ptr
	ex de, hl
	ld hl, #num_ia
	call man_vecentity_add
	ret

;; Llama al limpiador genérico
man_ia_clean::
	ld hl, #_ia_last_ptr
	ex de, hl
	ld hl, #num_ia
	ld ix, #ia_ptr_array
	call man_vecentity_clean
	ret

