.module render

.globl sys_render_init
.globl sys_render_update
.globl add_points
.globl draw_time_points
.globl dec_points
.globl backbuffer_in_use
.globl draw_lvl
.globl lvl_text
.globl draw_lvl_chars
.globl draw_lives_chars
.globl draw_number_life
.globl cpct_setDrawCharM1_asm

.globl cpct_setPalette_asm
.globl check_just_created_ix
.globl check_just_created_iy
.globl sys_render_switch_buffers

.globl draw_vidas_level

.globl cpct_setVideoMemoryPage_asm

.globl sys_render_clean_entity

backbuffer_add == 0x8000
backbuffer_add_h = 0x80
backbuffer_add_l = 0x00

video_mem_add == 0xC000
video_mem_add_h == 0xC0
video_mem_add_l = 0x00

backbuffer_page_shifted = 0x20
video_mem_page_shifted = 0x30

;; INPUT DE: ScreenPtr in mem_address (relative to C000)
.macro draw_time_points_twice
    push de
    call draw_time_points
    pop de
    ex de, hl
    ld de, #0x4000
    or a
    sbc hl, de
    ex de, hl
    call draw_time_points
.endm

.macro draw_vidas_level_twice
    ld de, #0xC000
    call draw_vidas_level 
    ld de, #0x8000
    call draw_vidas_level
.endm

;;INPUT DE = memory address where to print character (relative to C000)
;;this function prints in C000 and 8000
.macro draw_lvl_numbers_twice
    push de
    call draw_lvl
    pop de
    ex de, hl
    ld de, #0x4000
    or a
    sbc hl, de
    ex de, hl
    call draw_lvl
.endm

;;INPUT DE = memory address where to print character (relative to C000)
;;this function prints in C000 and 8000
.macro draw_lives_numbers_twice
    push de
    call draw_number_life
    pop de
    ex de, hl
    ld de, #0x4000
    or a
    sbc hl, de
    ex de, hl
    call draw_number_life
.endm

